Subject: Re: [yang-doctors] automating yang doctor reviews

From: Christian Hopps <[email-masked]>
Date: Tue, 15 May 2018 03:29:15 -0400

Martin Bjorklund <[email-masked]> writes:

> Hi Kent,
>
> While I appreciate the effort, I'm not sure this will actually make
> the YANG doctor's job any easier.  For example, re including the
> command to generate the tree diagram - if people knew how to do this
> properly, they could as easily write a Makefile (or similar) that
> always generate the diagram so that the tree diagram is always up to
> date.  But we know that this is not the case.  So why do we think that
> the addition of the 'gen' attribute will make people produce good
> drafts?

Actually I'm guessing there are many people that would not think to automate any of this, or would not be comfortable enough with make to do so if hinted at. :)

The tree diagrams should be able to be automatically generated without specific commands though, given a module name and optional path to the root of the sub-tree to insert.

> And sometimes examples and tree diagrams are manually edited for
> formatting reason (e.g., replace chunks of noise with "...").   This
> is difficult to capture formally, and people will still have to
> validate examples.

Well we could simply replace "\s*...\s*" with an empty string, and document that we will do so. :)

> As have been pointed out, there is often dependencies to other
> modules; capturing all this seems a bit tricky.  And the question is
> what problem is actually solves.

I think another person mentioned that the document can change after yang doctor review. In any case it can't hurt to have a set of tools that automatically test as much as possible for authors, submission, reviewers and prior to publication.

Thanks,
Chris.

> Another approach might be to encourage people to keep their draft work
> on github, have separate files for examples, use 'make' to generate
> tree diagrams and to validate examples.  This is less formal, but
> achieves the same goal.
>
>
> /martin
>
>
>
> Kent Watsen <[email-masked]> wrote:
>>
>> Doctors,
>>
>> Here's a stab at how we might automate the basic parts of a YANG
>> Doctor review, something I've mentioned wanting at the YD-lunch
>> meeting at the last two IETF meetings.
>>
>> I'll be the first to say that this proposal has issues, but hopefully
>> it's in the ballpark, and we can finish it off together, assuming
>> there is interest in bringing it forward at all...
>>
>> Note, I assume that this document will be AD-sponsored, just like RFC
>> 7991 was, hence why the draft name is what it is.
>>
>> PS: I'm falling into a black hole, and may not reply to any responses
>> until early next week.
>>
>> Kent
>>
>>
>
> _______________________________________________
> yang-doctors mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/yang-doctors